<?php

namespace DigitalPoint\Cloudflare\Data;

class Worker
{
	public function getImageProxyWorker(): string
	{
		return 'export default {
  async fetch(request, env, ctx) {

    const { searchParams } = new URL(request.url);
    let image = searchParams.get("i") || "";

    if (!new RegExp("^https?://").test(image))
    {
      return new Response("Invalid or missing image url (`i` parameter).", {
  	  status: 400, 
        statusText: "Bad Request", 
        headers: {
          "Cache-control": "no-store, no-cache, must-revalidate, post-check=0, pre-check=0",
          "Pragma": "no-cache"
        }
      });
    }

    return await fetch(image, {
      headers: {
        Accept: "image/*,*/*;q=0.8",
        "User-Agent": request.headers.get("User-Agent") || "",
        "Language-Accept": "' . \XF::app()->language(\XF::options()->defaultLanguageId)->getLanguageCode() . '"
      }
    })
  },
};';
	}

	public function getUrlProxyWorker(): string
	{
		return 'export default {
  async fetch(request, env, ctx) {

    const { searchParams } = new URL(request.url);
    let url = searchParams.get("u") || "";

    if (!new RegExp("^https?://").test(url))
    {
      return new Response("Invalid or missing url (`u` parameter).", {
  	  status: 400, 
        statusText: "Bad Request", 
        headers: {
          "Cache-control": "no-store, no-cache, must-revalidate, post-check=0, pre-check=0",
          "Pragma": "no-cache"
        }
      });
    }

    return await fetch(url, {
      headers: {
        "User-Agent": request.headers.get("User-Agent") || "",
        "Language-Accept": "' . \XF::app()->language(\XF::options()->defaultLanguageId)->getLanguageCode() . '"
      }
    })
  },
};';
	}

}