<?php

namespace DigitalPoint\Cloudflare\Job;

use XF\Job\AbstractJob;

class FirewallRuleDelete extends AbstractJob
{
	public function run($maxRunTime)
	{
		if ($this->data['id'])
		{
			/** @var \DigitalPoint\Cloudflare\Repository\Cloudflare $cloudflareRepo */
			$cloudflareRepo = $this->app->repository('DigitalPoint\Cloudflare:Cloudflare');
			$cloudflareRepo->deleteFirewallAccessRule($this->data['id']);
		}

		return $this->complete();
	}

	public function getStatusMessage()
	{
		return \XF::phrase('deleting_firewall_rule');
	}

	public function canCancel()
	{
		return false;
	}

	public function canTriggerByChoice()
	{
		return false;
	}
}