<?php

namespace DigitalPoint\Cloudflare\League\Flysystem;

use InvalidArgumentException;

class MountManager extends \League\Flysystem\MountManager
{
	/**
	 * @param string $path
	 *
	 * @throws InvalidArgumentException
	 *
	 * @return string[] [:prefix, :path]
	 */
	protected function getPrefixAndPath($path)
	{
		if (strpos($path, '://') < 1) {
			throw new InvalidArgumentException('No prefix detected in path: ' . $path);
		}

		$split = explode('://', $path, 2);

		if (strpos($split[1], '/') !== false)
		{
			$pathSplit = explode('/', $split[1], 2);

			if (isset($this->filesystems[$split[0] . '/' . $pathSplit[0]]))
			{
				$split[0] .= '/' . $pathSplit[0];
			}
		}
		// Root of the file system, check if there's a sub-adapter for it.
		elseif (isset($this->filesystems[$split[0] . '/' . $split[1]]))
		{
			$split[0] .= '/' . $split[1];
		}

		return $split;
	}

}