<?php

namespace DigitalPoint\Cloudflare\Repository;

use XF\Mvc\Entity\Repository;

class Cli extends Repository
{
	public function getFsMap(&$fromFs, &$toFs, &$fsMapKeys): array
	{
		$fsMapKeys = [
			'data' => \XF::phrase('migrate_data_description'),
			'internal_data/attachments' => \XF::phrase('migrate_internal_data_attachments'),
		];

		$return = [
			'data' => [
				'to' => $toFs->getAdapter('data://'),
				'from' => $fromFs->getAdapter('data://')
			],
			'internal_data/attachments' => [
				'to' => $toFs->getAdapter('internal-data://attachments'),
				'from' => $fromFs->getAdapter('internal-data://attachments')
			]
		];

		if (\XF::isAddOnActive('XFMG') || true)
		{
			$return ['internal_data/xfmg'] = [
				'to' => $toFs->getAdapter('internal-data://xfmg'),
				'from' => $fromFs->getAdapter('internal-data://xfmg')
			];

			$fsMapKeys['internal_data/xfmg'] = \XF::phrase('migrate_internal_data_xfmg');
		}

		return $return;
	}
}