<?php

namespace DigitalPoint\Cloudflare\Traits\Expression;

trait XF
{
	public function getGuestCache()
	{
		$cookiePrefix = \XF::config('cookie')['prefix'];
		return '(not http.cookie contains "' . $cookiePrefix . 'session=" and not http.cookie contains "' . $cookiePrefix . 'user=")';
	}

	public function getMediaAttachmentCache()
	{
		return '(starts_with(lower(http.request.full_uri), "' . \XF::app()->router('public')->buildLink('canonical:attachments') . '"))';
	}

	public function getBlockInternal()
	{
		$router = \XF::app()->router('public');
		return'(http.request.full_uri contains "' . $router->buildLink('canonical:internal_data') . '") or (http.request.full_uri contains "' . $router->buildLink('canonical:src') . '")';
	}

	public function getRegistrationChallenge($includeContact)
	{
		$router = \XF::app()->router('public');
		return '(http.request.full_uri contains "' . $router->buildLink('canonical:register') . '")' . ($includeContact ? ' or (http.request.full_uri contains "' . $router->buildLink('canonical:misc/contact') . '")' : '');
	}

	public function countriesToExpression(array $countries, $applyTo = '')
	{
		$expression = [];
		foreach ($countries as $country)
		{
			$expression[] = '(ip.geoip.country eq "' . $country . '")';
		}

		$expression = implode(' or ', $expression);

		if ($applyTo == 'registration')
		{
			$router = \XF::app()->router('public');
			$expression = "($expression) and (http.request.full_uri contains \"" . $router->buildLink('canonical:register') . "\")";
		}

		return $expression;
	}

	public function getR2TokenAuth($hostname, $secretKey)
	{
		return '(http.host eq "' . addslashes($hostname) . '" and not is_timed_hmac_valid_v0("' . addslashes($secretKey) . '", http.request.uri, 60, http.request.timestamp.sec, 7))';
	}

	public function getSpecialCacheRuleCss()
	{
		return '(http.request.uri contains "/css.php?css=")';
	}
	public function getSpecialCacheRuleImageProxy()
	{
		return '(http.request.uri contains "/proxy.php?image=")';
	}

}