<?php

namespace DigitalPoint\Cloudflare\XF\ApprovalQueue;

class User extends XFCP_User
{
	public function actionSpamClean(\XF\Entity\User $user)
	{
		parent::actionSpamClean($user);

		if (\XF::app()->options()->cloudflareBlockIpsSpamClean)
		{
			$ips = \XF::app()->repository('XF:Ip')->getIpsByUser($user);

			if ($ips)
			{
				/** @var \DigitalPoint\Cloudflare\Repository\Cloudflare $cloudflareRepo */
				$cloudflareRepo = \XF::app()->repository('DigitalPoint\Cloudflare:Cloudflare');

				foreach ($ips as $ip)
				{
					if ($ip['last_date'] + (30 * 86400) > \XF::$time)
					{
						$cloudflareRepo->addFirewallAccessRule(
							\XF\Util\Ip::convertIpBinaryToString($ip['ip']),
							0,
							'',
							'block',
							\XF::phrase('used_by_spammer_x', ['user' => $user->username]),
							\XF::options()->cloudflareFirewallExpireDays
						);
					}
					else
					{
						// Now into IPs that haven't been used in the last 30 days.
						break;
					}
				}

			}

		}
	}
}

// ******************** FOR IDE AUTO COMPLETE ********************
if (false)
{
	class XFCP_User extends \XF\ApprovalQueue\User {}
}