<?php

namespace DigitalPoint\Cloudflare\XF\Template;

class Templater extends XFCP_Templater
{
	protected $areEdgeCaching = null;

	public function fnCsrfInput($templater, &$escape)
	{
		\XF::$versionId;
		if ($this->canEdgeCache())
		{
			$escape = false;
			return '<input type="hidden" name="_xfToken" value="" />';
		}
		return parent::fnCsrfInput($templater, $escape);
	}

	public function fnCsrfToken($templater, &$escape)
	{
		if ($this->canEdgeCache())
		{
			return '';
		}
		return parent::fnCsrfToken($templater, $escape);
	}

	public function canEdgeCache()
	{
		if ($this->areEdgeCaching !== null)
		{
			return $this->areEdgeCaching;
		}
		if (!\XF::visitor()->user_id &&
			\XF::options()->cfPageCachingSeconds &&
			\XF::app()->container('app.classType') === 'Pub' &&
			substr(\XF::app()->request()->getRoutePath(), 0, 8) !== 'register' &&
			substr(\XF::app()->request()->getRoutePath(), 0, 5) !== 'login' &&
			\XF::app()->response()->contentType() === 'text/html' &&
			\XF::app()->response()->httpCode() == 200 &&
			(!\XF::visitor()->style_id || \XF::visitor()->style_id == \XF::options()->defaultStyleId) &&
			(!\XF::visitor()->language_id || \XF::visitor()->language_id == \XF::options()->defaultLanguageId) &&
			!\XF::$debugMode)
		{
			$this->areEdgeCaching = true;
		}
		else
		{
			$this->areEdgeCaching = false;
		}
		return $this->areEdgeCaching;
	}
}


// ******************** FOR IDE AUTO COMPLETE ********************
if (false)
{
	class XFCP_Templater extends \XF\Template\Templater {}
}